#!/usr/bin/python3
#FHSE in mhz
#FHSE = 25
FHSE = 8

#cpu search frequency range
fmin = 84
#fmin = 96
fmax = 84 
#fmax = 96 
#fmax = 120

#clk1 = clk / m
m = list(range(1,64))
#vco = clk1 * n
n = list(range(0,512))
#vco / p = system clock - mcu speed (not systick)
p = list(range(2,9,2))
#vco / q = 48mhz - usb
q = list(range(1,16))
for mi in m:
    for ni in n:
        fvco = FHSE * ni / mi
        if fvco > 432:
            continue
        for qi in q:
            fusb = fvco / qi
            if not ( fusb == int(fusb) and fusb == 48 ):
                    continue
            for pi in p:
                fcpu = fvco / pi            
                if not fcpu == int(fcpu):
                    continue                
                if fusb == 48 \
                   and ( fcpu >= fmin and fcpu <= fmax):
                    print('FHSE:', FHSE,
                      'm:', mi,
                      'n:', ni,
                      'p:', pi,
                      '(RCC_PLLP_DIV' + str(pi) + ')',
                      'q:', qi,
                      'fusb:', fusb,
                      'fcpu:', fcpu)
